{*******************************************************************************

  Animation Splash Form (ASF)

  :     Andy BitOff, asf@bitoff.ru, http://bitoff.ru/asf-main ICQ:95044580, -, 
  Copyright: Andy BitOff
  :      11.08.2009
  :    2.2.3

  : GDI+ (GDIPAPI, GDIPOBJ, GDIPUTIL)

********************************************************************************

================================================================================
  ASFMain unit

  TAnimationSplashForm
         
       .
          .

================================================================================

   
  ------------------------------------------------------------------------------
  2.2.3
    + onEndFade -      
    +  100%     
  2.2.2
    + AttemptedClosure -    
  2.2.0
    + onKeyPress
    + onKeyDown
    + onKeyUp
    + ClosingAllow -    (Default - True)
    *  
  2.0.0
    *      
    *  ,       
               ASFMain
    *  ,      
         -    
    +        .
    +      , ,    
    +   GetGPColor,       
    + :
        onStartSplash   -     
        onDestroySplash -     
        onBeforeDraw    -       
                            
        onAfterDraw     -       
                                 
                
          ProgressBarTotalParts   -   100% 
          ProgressBarPartComplite -    
          ProgressBarPercent      -    
        ProgressBarSectionColor -       
        BarDrawOnTime -  ProgressBar'    
    * :
        ProgressBarCurrentPart -> ProgressBarCurrentSection
        ProgressBarPatrs -> ProgressBarSectionsCount
        IncCurrentPart -> IncCurrentSection
        LoadingPartTime -> LoadingSectionTime
    *  
  1.3.1
    *      (  ;))
  1.3.0
    +   ,     .
    +    DelayBetweenPassage -   
      ,   , ,  
    !      .
             
    *  
  1.2.0
    *       ,   
      EurekaLog,   FastMM 4.92.
    *      ASF
  1.1.1
    *    
  1.1.0
    *    (defecator  - )
    *  
  1.0.0
    *        
    *     
  0.94.0
    +   ,    
    *    (   .
	      .,   ;))
    *   Access violation       Demo
    *  
  0.93.0
     
  ------------------------------------------------------------------------------

===============================================================================}


unit ASFMain;

interface

uses
  Windows, Messages, Classes, Graphics, SysUtils, Contnrs, Forms,
  GDIPAPI, GDIPOBJ, GDIPUTIL, ASFLists;

resourcestring
  eFileNotFound = 'File %s not found';
  eFileNotSupported = 'Unknown format.' + #13#10 + 'Stream: %s';
  eIndexOutOfBounds = 'Index out of bounds (%d)';


type
  TIconInfo = record
    IconIndex: Integer;
    IconPos: Integer;
    IconWidth: Integer;
    IconHeight: Integer;
  end;

  PProgressBarInfo = ^TProgressBarInfo;
  TProgressBarInfo = record
    BarVisible: Boolean;
    BarBorderVisible: Boolean;
    BarBox: TGPRect;
    BarColor: Cardinal;
    BarBorderColor: Cardinal;
    BarDrawOnTime: Boolean;
  end;

  TIconAnimation = (iaNone, iaFade, iaFadeColor, iaSlideTop, iaSlideLeft, iaSlideCorner);

  TEventType = (etKeyDown, etKeyUp, etKeyPress);

  TasfStartSplashEvent = procedure(Sender: TObject) of object;
  TasfDestroySplashEvent = procedure(Sender: TObject) of object;
  TasfBeforeDrawEvent = procedure(Sender: TObject; GPGraphics: TGPGraphics) of object;
  TasfAfterDrawEvent = procedure(Sender: TObject; GPGraphics: TGPGraphics) of object;
  TasfKeyPressEvent = procedure(Sender: TObject; var Key: Char) of object;
  TasfKeyDownEvent = procedure(Sender: TObject; var Key: Word; Shift: TShiftState) of object;
  TasfKeyUpEvent = TasfKeyDownEvent;
  TasfEndFade = procedure(Sender: TObject) of object;
//  TasfProgressPartCompliteEvent = procedure(Sender: TObject; Part: integer) of object;

  TAnimationSplashForm = class(TThread)
  private
    FAnimations: TObjectList;
    FBMPBackground: TGPBitmap;
    FClose: Boolean;
    FCritSec: TRTLCriticalSection;
    FAttemptedClosure: Boolean;
    FBarSectionsColor: array of cardinal;
    FClosingAllow: Boolean;
    FCurrentIconPosition: Integer;
    FDC: HDC;
    FDestroy: Boolean;
    FFadeSpeed: Integer;
    FGuid: string;
    FIconAnimation: TIconAnimation;
    FIconFullPaintPercent: Integer;
    FIconPosArray: array of TIconInfo;
    FIconPosLeft: Integer;
    FIconPosTop: Integer;
    FIcons: TImagesList;
    FIconSpace: Integer;
    FIconStep: Integer;
    FLoadingSectionTime: Integer;
    FonAfterDraw: TasfAfterDrawEvent;
    FonBeforeDraw: TasfBeforeDrawEvent;
    FonDestroySplash: TasfDestroySplashEvent;
    FOneSectionProgressSize: Integer;
    FonKeyDown: TasfKeyDownEvent;
    FonKeyPress: TasfKeyPressEvent;
    FonKeyUp: TasfKeyUpEvent;
    FonStartSplash: TasfStartSplashEvent;
    FOnEndFade: TasfEndFade;
    FProgressBar: PProgressBarInfo;
    FProgressBarCurrentSection: Integer;
    FProgressBarPartComplite: Integer;
    FProgressBarPercent: Integer;
    FProgressBarSectionsCount: Integer;
    FProgressBarTotalParts: Integer;
    FProgressIconCurrentItem: Integer;
    FProgressIconsVisible: Boolean;
    FrameNumber: integer;
    FSelfClose: Boolean;
    FSetedSectColor: Boolean;
    FShowTaskbarButton: Boolean;
    FSplashFormCaption: String;
    FSplashFormTopMost: Boolean;
    FStartCurrentSection: Integer;
    FTestSpeed: Boolean;
    FTextData: TTextItemList;
    FTickCountAll: Integer;
    FTickCountOld: Integer;
    FTickZero: Cardinal;
    FTimerInterval: Integer;
    FTransparent: integer;
    FTransparentOld: integer;
    FWaitClose: Integer;
    FEndFadeHasOperated: Boolean;
    function CreateMyWnd(): hWnd;
    procedure InitData;
    procedure TimerProc();
    procedure RenderForm(TransparentValue: byte; SourceImage: TGPBitmap);
    procedure TextOut(TextInfo: TTextItem; TextColor: Cardinal; GPGraphics: TGPGraphics; GPRect: TGPRectF);
    procedure SetProgressBarSectionsCount(const Value: Integer);
    procedure SetProgressBarCurrentSection(const Value: Integer);
    procedure SetLoadingSectionTime(const Value: Integer);
    function GetMyTickCount: Integer;
    procedure PaintIcons(GPGraphics: TGPGraphics);
    procedure SetProgressIconCurrentItem(const Value: Integer);
    procedure SetProgressIconsVisible(const Value: Boolean);
    procedure SetIconFullPaintPercent(Value: Integer);
    procedure SetIconAnimation(const Value: TIconAnimation);
    procedure DrawSplash;
    procedure PaintProgressBar(GPGraphics: TGPGraphics);
    function GetAnimationRect(ItemIndex: Integer; GPImageAttributes: TGPImageAttributes): TGPRectF;
    function CalcCurrentIconPos(IconItem: Integer): Integer;
    function GetAnimations(Index: Integer): TAnimationFrames;
    procedure SetAnimations(Index: Integer; const Value: TAnimationFrames);
    function AnimationValidIndex(Index: integer): Boolean;
    procedure PaintAnimations(GPGraphics: TGPGraphics);
    procedure SetFadeSpeed(Value: Integer);
    function GetProgressBarSectionColor: cardinal;
    function GetProgressBarPartComplite: Integer;
    function GetProgressBarPercent: Integer;
    function GetProgressBarTotalParts: Integer;
    procedure PaintText(GPGraphics: TGPGraphics);
    procedure SetIconPosLeft(const Value: Integer);
    procedure SetIconPosTop(const Value: Integer);
    procedure SetIconSpace(const Value: Integer);
    procedure SetIconStep(const Value: Integer);
    function SetLengthIconArray: Boolean;
    procedure SaveTextData(Stream: TStream);
    procedure SaveRectData(Stream: TStream; GPRect: TGPRect);
    procedure SaveStringData(Stream: TStream; Str: String);
    procedure SaveIconsData(Stream: TStream);
    procedure SaveAnimationsData(Stream: TStream);
    procedure LoadStringData(Stream: TStream; var Str: String);
    procedure LoadRectData(Stream: TStream; var GPRect: TGPRect);
    procedure LoadFromFile(FileName: string);
    procedure LoadFromStream(Stream: TStream);
    procedure Resume;
    procedure LoadAnimationsData(Stream: TStream);
    procedure LoadIconsData(Stream: TStream);
    procedure LoadTextData(Stream: TStream);
    procedure SetProgressBarSectionColor(const Value: cardinal);
    procedure SetProgressBarPartComplite(const Value: Integer);
    procedure SetProgressBarPercent(const Value: Integer);
    procedure SetProgressBarTotalParts(const Value: Integer);
    function GetTimerInterval: Integer;
    procedure PressKey(var aMsg: TMsg; EventType: TEventType);
  protected
    procedure Execute; override;
  published
    
  public
    constructor Create(Width, Height, ResolutionX, ResolutionY: Integer);
    constructor CreateFrom(BackGroundFileName: string); overload;
    constructor CreateFrom(Stream: TStream); overload;
    constructor CreateFrom(ResourceName: string; ResourceType: PChar); overload;
    constructor CreateFullFrom(FileName: string; Start: Boolean = True); overload;
    constructor CreateFullFrom(Stream: TStream; Start: Boolean = True); overload;
    constructor CreateFullFrom(ResourceName: string; ResourceType: PChar; Start: Boolean = True); overload;
    destructor Destroy; override;
    procedure StartSplash;
    procedure CloseSplash(CloseDelay: Integer; Destroy: Boolean = True);
    property ClosingAllow: Boolean read FClosingAllow write FClosingAllow;
    property AttemptedClosure: Boolean read FAttemptedClosure;
    procedure SaveToFile(FileName: string);
    procedure SaveToStream(Stream: TStream);
    procedure SetTimerInterval(Interval: Integer);
    function TestSpeedDrawSplash: Integer;
    procedure IncCurrentSection;
    procedure IncCurrentItemIcon;
    function AnimationsAdd(Value: TAnimationFrames): Integer;
    function AnimationsAddFromFile(FileName: string): Integer;
    function AnimationsAddFromResource(ResourceName: string; ResourceType: PChar): Integer;
    function AnimationsAddFromStream(Stream: TStream): Integer;
    function AnimationsCount: Integer;
    property Animations[Index: Integer]: TAnimationFrames read GetAnimations write SetAnimations;
    property FadeSpeed: Integer read FFadeSpeed write SetFadeSpeed;
    property IconAnimation: TIconAnimation read FIconAnimation write SetIconAnimation;
    property IconFullPaintPercent: Integer read FIconFullPaintPercent write SetIconFullPaintPercent;
    property IconPosLeft: Integer read FIconPosLeft write SetIconPosLeft;
    property IconPosTop: Integer read FIconPosTop write SetIconPosTop;
    property Icons: TImagesList read FIcons write FIcons;
    property IconSpace: Integer read FIconSpace write SetIconSpace;
    property IconStep: Integer read FIconStep write SetIconStep;
    property LoadingSectionTime: Integer read FLoadingSectionTime write SetLoadingSectionTime;
    property ProgressBar: PProgressBarInfo read FProgressBar write FProgressBar;
    property ProgressBarCurrentSection: Integer read FProgressBarCurrentSection write SetProgressBarCurrentSection;
    property ProgressBarSectionsCount: Integer read FProgressBarSectionsCount write SetProgressBarSectionsCount;
    property ProgressBarTotalParts: Integer read GetProgressBarTotalParts write SetProgressBarTotalParts;
    property ProgressBarPartComplite: Integer read GetProgressBarPartComplite write SetProgressBarPartComplite;
    property ProgressBarPercent: Integer read GetProgressBarPercent write SetProgressBarPercent;
    property ProgressBarSectionColor: cardinal read GetProgressBarSectionColor write SetProgressBarSectionColor;
    property ProgressIconCurrentItem: Integer read FProgressIconCurrentItem write SetProgressIconCurrentItem;
    property ProgressIconsVisible: Boolean read FProgressIconsVisible write SetProgressIconsVisible;
    property ShowTaskbarButton: Boolean read FShowTaskbarButton write FShowTaskbarButton;
    property SplashFormCaption: String read FSplashFormCaption write FSplashFormCaption;
    property SplashFormTopMost: Boolean read FSplashFormTopMost write FSplashFormTopMost;
    property TextData: TTextItemList read FTextData write FTextData;
    property TimerInterval: Integer read GetTimerInterval write SetTimerInterval;
    property onStartSplash: TasfStartSplashEvent read FonStartSplash write FonStartSplash;
    property onDestroySplash: TasfDestroySplashEvent read FonDestroySplash write FonDestroySplash;
    property onBeforeDraw: TasfBeforeDrawEvent read FonBeforeDraw write FonBeforeDraw;
    property onAfterDraw: TasfAfterDrawEvent read FonAfterDraw write FonAfterDraw;
    property onKeyPress: TasfKeyPressEvent read FonKeyPress write FonKeyPress;
    property onKeyDown: TasfKeyDownEvent read FonKeyDown write FonKeyDown;
    property onKeyUp: TasfKeyUpEvent read FonKeyUp write FonKeyUp;
    property OnEndFade: TasfEndFade read FOnEndFade write FOnEndFade;
  end;

function WndProc(Wnd: HWND; message: UINT; wParam: Integer; lParam: Integer) : Integer; stdcall;
function GetGPColor(Color: TColor; Alpha: byte): cardinal;


var
  AnimationSplashForm: TAnimationSplashForm;

implementation

uses
  ActiveX;

const
  RsSystemIdleProcess = 'System Idle Process';
  RsSystemProcess = 'System Process';
  InitProcessClassName = 'SplashWindow';

type
  TFixedStreamAdapter = class(TStreamAdapter)
    public
      function Stat(out statstg: TStatStg; grfStatFlag: Longint): HResult; override; stdcall;
    end;


var
  AppHandle: HWND;
  Msg: TMsg;
  FadeColorMatrix: TColorMatrix =  //   
     ((1.0, 0.0, 0.0, 0.0, 0.0),
      (0.0, 1.0, 0.0, 0.0, 0.0),
      (0.0, 0.0, 1.0, 0.0, 0.0),
      (0.0, 0.0, 0.0, 1.0, 0.0),
      (0.0, 0.0, 0.0, 0.0, 1.0));
  FadeColorColorMatrix: TColorMatrix =  //    
     ((0.299, 0.299, 0.299, 0.0, 0.0),
      (0.587, 0.587, 0.587, 0.0, 0.0),
      (0.114, 0.114, 0.114, 0.0, 0.0),
      (0.0, 0.0, 0.0, 1.0, 0.0),
      (0.0, 0.0, 0.0, 0.0, 1.0));



function GetGPColor(Color: TColor; Alpha: byte): cardinal;
begin
  Result := (Color and $FF) shl 16 + Color and $FF00 + (Color and $FF0000) shr 16 + Alpha shl 24;
end;



function WndProc(Wnd: HWND; message: UINT; wParam: Integer; lParam: Integer) : Integer; stdcall;
begin
  case message of
    WM_KEYDOWN: begin
      TAnimationSplashForm(GetWindowLong(Wnd, GWL_USERDATA)).PressKey(msg, etKeyDown);
    end;
    WM_KEYUP: begin
      TAnimationSplashForm(GetWindowLong(Wnd, GWL_USERDATA)).PressKey(msg, etKeyUp);
    end;
    WM_CHAR: begin
      TAnimationSplashForm(GetWindowLong(Wnd, GWL_USERDATA)).PressKey(msg, etKeyPress);
    end;
    WM_TIMER: begin
      TAnimationSplashForm(GetWindowLong(Wnd, GWL_USERDATA)).TimerProc();
      result := 0;
      Exit;
    end;
    WM_SYSCOMMAND: begin
      if wParam = SC_CLOSE  then begin
        with TAnimationSplashForm(GetWindowLong(Wnd, GWL_USERDATA)) do begin
          if not (FSelfClose or ClosingAllow) then begin
            FAttemptedClosure := True;
            result := 0;
            Exit;
          end;
        end;
      end;
    end;
    WM_DESTROY: begin
      PostQuitMessage(0);
      result := 0;
      Exit;
    end;
  end;
  result := DefWindowProc(Wnd, message, wParam, lParam);
end;




{ TFixedStreamAdapter }

function TFixedStreamAdapter.Stat(out statstg: TStatStg; grfStatFlag: Integer): HResult;
begin
  Result := inherited Stat(statstg, grfStatFlag);
  statstg.pwcsName := nil;
end;




{ TAnimationSplashForm }

constructor TAnimationSplashForm.CreateFrom(BackGroundFileName: string);
var
  st: TFileStream;
begin
  if not FileExists(BackGroundFileName) then
    raise Exception.Create(Format(eFileNotFound , [BackGroundFileName]));
  st := TFileStream.Create(BackGroundFileName, fmOpenRead);
  try
    FBMPBackground := TGPBitmap.Create(TFixedStreamAdapter.Create(st));
    InitData();
    inherited Create(True);
  finally
    st.Free;
  end;
end;

constructor TAnimationSplashForm.Create(Width, Height, ResolutionX, ResolutionY: Integer);
begin
  FBMPBackground := TGPBitmap.Create(Width, Height);
  FBMPBackground.SetResolution(ResolutionX, ResolutionY);
  InitData();
  inherited Create(True);
end;

constructor TAnimationSplashForm.CreateFrom(Stream: TStream);
begin
  FBMPBackground := TGPBitmap.Create(TFixedStreamAdapter.Create(Stream));
  InitData();
  inherited Create(True);
end;

constructor TAnimationSplashForm.CreateFrom(ResourceName: string; ResourceType: PChar);
var
  st: TResourceStream;
begin
  st := TResourceStream.Create(Hinstance, ResourceName, ResourceType);
  try
    FBMPBackground := TGPBitmap.Create(TFixedStreamAdapter.Create(st));
    InitData();
    inherited Create(True);
  finally
    st.Free;
  end;
end;

constructor TAnimationSplashForm.CreateFullFrom(FileName: string; Start: Boolean = True);
begin
  InitData();
  LoadFromFile(FileName);
  inherited Create(True);
  if Start then
    StartSplash;
end;

constructor TAnimationSplashForm.CreateFullFrom(Stream: TStream; Start: Boolean = True);
begin
  InitData();
  LoadFromStream(Stream);
  inherited Create(True);
  if Start then
    StartSplash;
end;

constructor TAnimationSplashForm.CreateFullFrom(ResourceName: string; ResourceType: PChar; Start: Boolean = True);
var
  st: TResourceStream;
begin
  st := TResourceStream.Create(Hinstance, ResourceName, ResourceType);
  try
    InitData();
    LoadFromStream(St);
    inherited Create(True);
    if Start then
      StartSplash;
  finally
    st.Free;
  end;
end;

destructor TAnimationSplashForm.Destroy;
begin
  if Assigned(FOnDestroySplash) then FOnDestroySplash(Self);
  KillTimer(AppHandle, 0);
  FAnimations.Free;
  FIcons.Free;
  TextData.Free;
  Dispose(FProgressBar);
  FBarSectionsColor := nil;
  FBMPBackground.Free;
  DeleteCriticalSection(FCritSec);
  SetForegroundWindow(Application.Handle);
  inherited;
  DestroyWindow(AppHandle);
  Windows.UnregisterClass(PChar(InitProcessClassName + FGuid), hInstance);
end;

procedure TAnimationSplashForm.Execute;
begin
  SetLengthIconArray();
  FreeOnTerminate := True;
  AppHandle := CreateMyWnd;
  if AppHandle = 0 then
    Exit;
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_NORMAL);
  SetWindowLong(AppHandle, GWL_USERDATA, Integer(Self));
  SetTimer(AppHandle, 0, FTimerInterval, nil);
  while GetMessage(Msg, 0, 0, 0) do begin
    TranslateMessage(Msg);
    DispatchMessage(Msg);
    sleep(0);
  end;
end;

function TAnimationSplashForm.CreateMyWnd(): hWnd;
var
  wc: WndClass;
  f: Integer;
  Guid: TGuid;
begin
  wc.style := CS_HREDRAW or CS_VREDRAW;
  wc.lpfnWndProc := @WndProc;
  wc.cbClsExtra := 0;
  wc.cbWndExtra := 0;
  wc.hInstance := hInstance;
  wc.hIcon := 0;
  wc.hCursor := 0;
  wc.hbrBackground := COLOR_INACTIVECAPTION;
  wc.lpszMenuName := nil;
  CreateGuid(Guid);
  FGuid := StringReplace(GuidToString(Guid), '-', '', [rfReplaceAll]);
  wc.lpszClassName := PChar(InitProcessClassName + FGuid);
  result := 0;
  if Windows.RegisterClass(wc) = 0 then
    Exit;
  f := WS_EX_APPWINDOW;
  if not ShowTaskbarButton then
    f := WS_EX_TOOLWINDOW;
  if SplashFormTopMost then
    f := f or WS_EX_TOPMOST;
  result := CreateWindowEx(f, PChar(InitProcessClassName + FGuid),
      PChar(SplashFormCaption), WS_POPUP,
      GetSystemMetrics(SM_CXFULLSCREEN) div 2 - Integer(FBMPBackground.GetWidth) div 2,
      GetSystemMetrics(SM_CYFULLSCREEN) div 2 - Integer(FBMPBackground.GetHeight) div 2,
      FBMPBackground.GetWidth,
      FBMPBackground.GetHeight,
      0, 0, hInstance, nil);
end;

procedure TAnimationSplashForm.InitData;
begin
  InitializeCriticalSection(FCritSec);
  FSelfClose := False;
  ClosingAllow := True;
  FAttemptedClosure := False;
  FTimerInterval := 100;
  FAnimations := TObjectList.Create(True);
  FIcons := TImagesList.Create;
  FClose := False;
  New(FProgressBar);
  with ProgressBar^ do begin
    BarVisible := False;
    BarBorderVisible := True;
    BarBox := MakeRect(0, 0, 100, 20);
    BarColor := $FFFFFFFF;
    BarBorderColor := $FFFFFFFF;
    BarDrawOnTime := True;
  end;
  ProgressBarTotalParts := 100;
  ProgressBarPartComplite := 0;
  ProgressBarSectionsCount := 1;
  TextData := TTextItemList.Create;
  FCurrentIconPosition := 0;
  FFadeSpeed := 7;
  FProgressIconCurrentItem := 0;
  FrameNumber := 0;
  FStartCurrentSection := 0;
  FTickCountAll := 0;
  FTickCountOld := 0;
  FTickZero := 0;
  FTransparent := 0;
  FTransparentOld := 255;
  IconFullPaintPercent := 100;
  LoadingSectionTime := 0;
  ProgressIconsVisible := True;
  ProgressBarSectionsCount := 1;
  FSetedSectColor := False;
  FEndFadeHasOperated := False;
end;

procedure TAnimationSplashForm.CloseSplash(CloseDelay: Integer; Destroy: Boolean = True);
begin
  FWaitClose := CloseDelay;
  FClose := True;
  FDestroy := Destroy;
end;

procedure TAnimationSplashForm.StartSplash;
begin
  FClose := False;
  FOneSectionProgressSize := FProgressBar.BarBox.Width div FProgressBarSectionsCount;
  if not FSetedSectColor then
    FBarSectionsColor[0] := ProgressBar^.BarColor;
  if Assigned(FOnStartSplash) then FonStartSplash(Self);
  Resume;
end;

procedure TAnimationSplashForm.Resume;
begin
  inherited;
end;

procedure TAnimationSplashForm.SetTimerInterval(Interval: Integer);
begin
  FTimerInterval := Interval;
end;

function TAnimationSplashForm.GetTimerInterval: Integer;
begin
  Result := FTimerInterval;
end;

procedure TAnimationSplashForm.SetFadeSpeed(Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    if Value < 1 then
      Value := 1
    else
      if Value > 255 then
        Value := 255;
    FFadeSpeed := Value;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetProgressBarSectionsCount(const Value: Integer);
var
  I: Integer;
begin
  EnterCriticalSection(FCritSec);
  try
    if Value > 0 then
      FProgressBarSectionsCount := Value
    else
      FProgressBarSectionsCount := 1;
    FProgressBarCurrentSection := 1;
    FOneSectionProgressSize := FProgressBar.BarBox.Width div FProgressBarSectionsCount;
    SetLength(FBarSectionsColor, FProgressBarSectionsCount);
    for I := 0 to Length(FBarSectionsColor) - 1 do begin
      FBarSectionsColor[i] := ProgressBar^.BarColor;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetProgressBarCurrentSection(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    if Value <= 0 then
      FProgressBarCurrentSection := 1;
    if Value <= FProgressBarSectionsCount then
      FProgressBarCurrentSection := Value
    else
      FProgressBarCurrentSection := FProgressBarSectionsCount;
    FStartCurrentSection := FOneSectionProgressSize * (FProgressBarCurrentSection - 1);
    FTickCountAll := 0;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.IncCurrentSection;
begin
  EnterCriticalSection(FCritSec);
  try
    if FProgressBarCurrentSection < FProgressBarSectionsCount then
      ProgressBarCurrentSection := ProgressBarCurrentSection + 1
    else
      ProgressBarCurrentSection := FProgressBarSectionsCount;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetLoadingSectionTime(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    if Value > 0 then
      FLoadingSectionTime := Value
    else
      FLoadingSectionTime := 1;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetProgressIconsVisible(const Value: Boolean);
begin
  FProgressIconsVisible := Value;
end;

procedure TAnimationSplashForm.SetIconPosLeft(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    FIconPosLeft := Value;
  finally
    LeaveCriticalSection(FCritSec);
  end;          
end;

procedure TAnimationSplashForm.SetIconPosTop(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    FIconPosTop := Value;
  finally
    LeaveCriticalSection(FCritSec);
  end;          
end;

procedure TAnimationSplashForm.SetIconSpace(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    FIconSpace := Value;
  finally
    LeaveCriticalSection(FCritSec);
  end;          
end;

procedure TAnimationSplashForm.SetIconStep(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    FIconStep := Value;
  finally
    LeaveCriticalSection(FCritSec);
  end;          
end;

function TAnimationSplashForm.CalcCurrentIconPos(IconItem: Integer): Integer;
var
  I: Integer;
  a: Integer;
begin
  Result := IconPosLeft;
  for I := 0 to Length(FIconPosArray) - 1 do begin
    if FIconPosArray[i].IconIndex = -1 then
      Continue;
    a := IconStep;
    if i = 0 then
      a := 0
    else
      if a = 0 then
        a := FIconPosArray[i - 1].IconWidth;

    Result := Result + a;
    if i <> 0 then
      Result := Result + IconSpace;
  end;
end;

procedure TAnimationSplashForm.SetProgressIconCurrentItem(const Value: Integer);
var
  nf: Integer;

  function NextFree: Integer;
  var
    I: Integer;
  begin
    Result := Length(FIconPosArray) - 1;
    for I := 0 to Result do begin
      if FIconPosArray[i].IconIndex = -1 then begin
        Result := I;
        Break;
      end;
    end;
  end;

begin
  EnterCriticalSection(FCritSec);
  try
    if Icons <> nil then begin
      if FProgressIconCurrentItem <= Icons.Count - 1 then
        FProgressIconCurrentItem := Value
      else
        FProgressIconCurrentItem := Icons.Count - 1;
      nf := NextFree;
      if SetLengthIconArray() then begin
        FIconPosArray[nf].IconIndex := ProgressIconCurrentItem;
        FIconPosArray[nf].IconPos := CalcCurrentIconPos(ProgressIconCurrentItem);
        FIconPosArray[nf].IconWidth :=
            Icons.Items[FProgressIconCurrentItem].GetWidth;
        FIconPosArray[nf].IconHeight :=
            Icons.Items[FProgressIconCurrentItem].GetHeight;
      end;            
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.SetLengthIconArray: Boolean;
var
  i: Integer;
begin
  Result := False;
  if (Icons <> nil) and (Icons.Count <> 0) and (Length(FIconPosArray) <> Icons.Count) then begin
    SetLength(FIconPosArray, Icons.Count);
    for I := 0 to Length(FIconPosArray) - 1 do begin
      FIconPosArray[i].IconIndex := -1;
      FIconPosArray[i].IconPos := 0;
      FIconPosArray[i].IconWidth := 0;
      FIconPosArray[i].IconHeight := 0;
    end;
  end;
  if Length(FIconPosArray) <> 0 then
    Result := True;
end;

procedure TAnimationSplashForm.IncCurrentItemIcon;
begin
  EnterCriticalSection(FCritSec);
  try
    if Icons <> nil then begin
      if FProgressIconCurrentItem < Icons.Count - 1 then
        ProgressIconCurrentItem := ProgressIconCurrentItem + 1
      else
        ProgressIconCurrentItem := Icons.Count - 1;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetIconFullPaintPercent(Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    if Value > 100 then
      Value := 100;
    if Value < 0 then
      Value := 0;
    FIconFullPaintPercent := Value;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetIconAnimation(const Value: TIconAnimation);
begin
  EnterCriticalSection(FCritSec);
  try
    FIconAnimation := Value;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.GetMyTickCount: Integer;
begin
  Result := GetTickCount() - FTickZero;
end;

function TAnimationSplashForm.TestSpeedDrawSplash: Integer;
var
  TickCount: Integer;
begin
  TickCount := GetTickCount();
  FTestSpeed := True;
  DrawSplash();
  FTestSpeed := False;
  Result := GetMyTickCount() - TickCount;
end;

function TAnimationSplashForm.GetAnimations(Index: Integer): TAnimationFrames;
begin
  EnterCriticalSection(FCritSec);
  Result := nil;
  try
    if AnimationValidIndex(Index) then begin
      Result := TAnimationFrames(FAnimations.Items[index]);
    end
    else
      raise Exception.Create(Format(eIndexOutOfBounds, [Index]));
  finally
    LeaveCriticalSection(FCritSec);
  end;            
end;

procedure TAnimationSplashForm.SetAnimations(Index: Integer; const Value: TAnimationFrames);
begin
  EnterCriticalSection(FCritSec);
  try
    if (AnimationValidIndex(Index)) and (Value <> nil) then begin
      FAnimations.Items[index].Free;
      FAnimations.Items[index] := Value;
    end
    else
      raise Exception.Create(Format(eIndexOutOfBounds, [Index]));
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.AnimationsCount: Integer;
begin
  EnterCriticalSection(FCritSec);
  try
    Result := FAnimations.Count;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.AnimationsAdd(Value: TAnimationFrames): Integer;
var
  TmpVal: TAnimationFrames;
begin
  EnterCriticalSection(FCritSec);
  try
    Result := -1;
    if Value <> nil then begin
      TmpVal := TAnimationFrames.Create;
      TmpVal.Assign(Value);
      Result := FAnimations.Add(TmpVal);
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.AnimationsAddFromFile(FileName: string): Integer;
var
  tmpAnim: TAnimationFrames;
begin
  Result := -1;
  if not FileExists(FileName) then
    raise Exception.Create(Format(eFileNotFound , [FileName]));
  EnterCriticalSection(FCritSec);
  try
    tmpAnim := TAnimationFrames.CreateFrom(FileName);
    try
      Result := AnimationSplashForm.AnimationsAdd(tmpAnim);
    finally
      tmpAnim.Free;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.AnimationsAddFromStream(Stream: TStream): Integer;
var
  tmpAnim: TAnimationFrames;
begin
  Result := -1;
  EnterCriticalSection(FCritSec);
  try
    tmpAnim := TAnimationFrames.CreateFrom(Stream);
    try
      Result := AnimationSplashForm.AnimationsAdd(tmpAnim);
    finally
      tmpAnim.Free;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.AnimationsAddFromResource(ResourceName: string; ResourceType: PChar): Integer;
var
  tmpAnim: TResourceStream;
begin
  EnterCriticalSection(FCritSec);
  try
    tmpAnim := TResourceStream.Create(Hinstance, ResourceName, ResourceType);
    try
      Result := AnimationsAddFromStream(tmpAnim);
    finally
      tmpAnim.Free;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.GetProgressBarTotalParts: Integer;
begin
  EnterCriticalSection(FCritSec);
  try
    Result := FProgressBarTotalParts;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetProgressBarTotalParts(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    FProgressBarTotalParts := Value;
    ProgressBarPartComplite := 0;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.GetProgressBarPartComplite: Integer;
begin
  EnterCriticalSection(FCritSec);
  try
    Result := FProgressBarPartComplite;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetProgressBarPartComplite(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    if Value > FProgressBarTotalParts then
      FProgressBarPartComplite := FProgressBarTotalParts
    else
      FProgressBarPartComplite := Value;
    ProgressBarPercent := Value div (FProgressBarTotalParts div 100);
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.GetProgressBarPercent: Integer;
begin
  EnterCriticalSection(FCritSec);
  try
    Result := FProgressBarPercent;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetProgressBarPercent(const Value: Integer);
begin
  EnterCriticalSection(FCritSec);
  try
    FProgressBarPercent := Value;
    if Value > 100 then
      FProgressBarPercent := 100;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

function TAnimationSplashForm.GetProgressBarSectionColor: cardinal;
begin
  EnterCriticalSection(FCritSec);
  try
    Result := FBarSectionsColor[FProgressBarCurrentSection - 1];
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SetProgressBarSectionColor(const Value: cardinal);
begin
  EnterCriticalSection(FCritSec);
  try
    FBarSectionsColor[FProgressBarCurrentSection - 1] := Value;
    FSetedSectColor := True;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SaveToFile(FileName: string);
var
  st: TFileStream;
begin
  EnterCriticalSection(FCritSec);
  try
    st := TFileStream.Create(FileName, fmCreate or fmShareDenyWrite);
    try
      SaveToStream(st);
    finally
      st.Free;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.LoadFromFile(FileName: string);
var
  st: TFileStream;
begin
  EnterCriticalSection(FCritSec);
  try
    if not FileExists(FileName) then
      raise Exception.Create(Format(eFileNotFound , [FileName]));
    st := TFileStream.Create(FileName, fmOpenRead);
    try
      LoadFromStream(st);
    finally
      st.Free;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.LoadFromStream(Stream: TStream);
var
  i: integer;
  aSize: Int64;
  s: AnsiString;
  tmpStream: TMemoryStream;
begin
  EnterCriticalSection(FCritSec);
  try
    tmpStream := TMemoryStream.Create;
    try
      s := '12345678901';
      Stream.Read(s[1], 11);
      if s = 'ASFFullData' then begin
        Stream.Read(aSize, SizeOf(aSize));
        tmpStream.CopyFrom(Stream, aSize);
        FBMPBackground := TGPBitmap.Create(TFixedStreamAdapter.Create(tmpStream));
        Stream.Read(FShowTaskbarButton, SizeOf(FShowTaskbarButton));
        LoadStringData(Stream, FSplashFormCaption);
        Stream.Read(FSplashFormTopMost, SizeOf(FSplashFormTopMost));
        Stream.Read(FFadeSpeed, SizeOf(FFadeSpeed));
        Stream.Read(FTimerInterval, SizeOf(FTimerInterval));
        Stream.Read(s[1], 11);
        if s = 'ClosingAllo' then begin
          Stream.Read(FClosingAllow, SizeOf(FClosingAllow));
        end
        else begin
          Stream.Seek(-11, soCurrent);
        end;
        with ProgressBar^ do begin
          Stream.Read(BarVisible, SizeOf(BarVisible));
          Stream.Read(BarBorderVisible, SizeOf(BarBorderVisible));
          LoadRectData(Stream, BarBox);
          Stream.Read(BarColor, SizeOf(BarColor));
          Stream.Read(BarBorderColor, SizeOf(BarBorderColor));
          Stream.Read(BarDrawOnTime, SizeOf(BarDrawOnTime));
        end;
        Stream.Read(i, SizeOf(FProgressBarSectionsCount));
        ProgressBarSectionsCount := i;
        Stream.Read(s[1], 11);
        while s <> 'ASF_EndData' do begin
          if s = 'ASFTextData' then begin
            LoadTextData(Stream);
          end;
          if s = 'ASFIconData' then begin
            LoadIconsData(Stream);
          end;
          if s = 'ASFAnimData' then begin
            LoadAnimationsData(Stream);
          end;
          Stream.Read(s[1], 11);
        end;
      end
      else begin
        raise Exception.Create(Format(eFileNotSupported , ['ASFFullData']));
      end;
    finally
      tmpStream.Free;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.LoadRectData(Stream: TStream; var GPRect: TGPRect);
var
  i: Integer;
begin
  i := SizeOf(integer);
  Stream.Read(GPRect.X, i);
  Stream.Read(GPRect.Y, i);
  Stream.Read(GPRect.Width, i);
  Stream.Read(GPRect.Height, i);
end;

procedure TAnimationSplashForm.LoadStringData(Stream: TStream; var Str: String);
var
  i: Integer;
begin
  Stream.Read(i, SizeOf(i));
  SetLength(Str, i{ div 2});
  Stream.Read(Str[1], i);
end;

procedure TAnimationSplashForm.LoadTextData(Stream: TStream);
var
  I, a, NewIt, ti: Integer;
  tc: Cardinal;
  tb: Boolean;
  ts: String;
  tr: TGPRect;
begin
  Stream.Read(a, SizeOf(a));
  for I := 0 to a - 1 do begin
    NewIt := TextData.AddNewItem;
    with TextData.Items[NewIt] do begin
      Stream.Read(tb, SizeOf(tb));
      Visible := tb;
      Stream.Read(tb, SizeOf(tb));
      VisibleShadow := tb;
      LoadStringData(Stream, ts);
      Text := ts;
      LoadRectData(Stream, tr);
      TextBox := tr;
      Stream.Read(tc, SizeOf(tc));
      Color := tc;
      Stream.Read(tc, SizeOf(tc));
      ShadowColor := tc;
      LoadStringData(Stream, ts);
      FontName := ts;
      Stream.Read(ti, SizeOf(ti));
      FontSize := ti;
      Stream.Read(ti, SizeOf(ti));
      FontStyle := ti;
      Stream.Read(ti, SizeOf(ti));
      PositionH := TStringAlignment(ti);
      Stream.Read(ti, SizeOf(ti));
      PositionV := TStringAlignment(ti);
      Stream.Read(ti, SizeOf(ti));
      RenderingHint := TTextRenderingHint(ti);
    end;
  end;
end;

procedure TAnimationSplashForm.LoadIconsData(Stream: TStream);
var
  i: Integer;
  tb: Boolean;
  tmpStream: TMemoryStream;
begin
  tmpStream := TMemoryStream.Create;
  try
    Stream.Read(tb, SizeOf(tb));
    ProgressIconsVisible := tb;
    Stream.Read(i, SizeOf(i));
    IconFullPaintPercent := i;
    Stream.Read(i, SizeOf(IconAnimation));
    IconAnimation := TIconAnimation(i);
    Stream.Read(i, SizeOf(i));
    IconPosLeft := i;
    Stream.Read(i, SizeOf(i));
    IconPosTop := i;
    Stream.Read(i, SizeOf(i));
    IconSpace := i;
    Stream.Read(i, SizeOf(i));
    IconStep := i;
    Stream.Read(i, SizeOf(i));
    tmpStream.CopyFrom(Stream, i);
    tmpStream.Position := 0;
    Icons.LoadFromStream(tmpStream);
  finally
    tmpStream.Free;
  end;
end;

procedure TAnimationSplashForm.LoadAnimationsData(Stream: TStream);
var
  i, a: Integer;
  tmpStream: TMemoryStream;
  tmpAnim: TAnimationFrames;
begin
  tmpStream := TMemoryStream.Create;
  try
    Stream.Read(a, SizeOf(a)); //    
    Stream.Read(a, SizeOf(a));
    for i := 0 to a - 1 do begin
      Stream.Read(a, SizeOf(a));
      tmpStream.Clear;
      tmpStream.CopyFrom(Stream, a);
      tmpStream.Position := 0;
      tmpAnim := TAnimationFrames.CreateFrom(tmpStream);
      try
        AnimationsAdd(tmpAnim);
      finally
        tmpAnim.Free;
      end;
    end;
  finally
    tmpStream.Free;
  end;
end;


procedure TAnimationSplashForm.SaveToStream(Stream: TStream);
var
  aSize: Int64;
  tmpStream: TMemoryStream;
  FencoderClsid: TGUID;
begin
  EnterCriticalSection(FCritSec);
  try
    tmpStream := TMemoryStream.Create;
    try
      GetEncoderClsid('image/png', FencoderClsid);
      Stream.Write(AnsiString('ASFFullData'), 11);
      FBMPBackground.Save(TFixedStreamAdapter.Create(tmpStream), FencoderClsid);
      aSize := tmpStream.Size;
      Stream.Write(aSize, SizeOf(aSize));
      tmpStream.Position := 0;
      Stream.CopyFrom(tmpStream, aSize);
      Stream.Write(FShowTaskbarButton, SizeOf(FShowTaskbarButton));
      SaveStringData(Stream, FSplashFormCaption);
      Stream.Write(FSplashFormTopMost, SizeOf(FSplashFormTopMost));
      Stream.Write(FFadeSpeed, SizeOf(FFadeSpeed));
      Stream.Write(FTimerInterval, SizeOf(FTimerInterval));
      Stream.Write(AnsiString('ClosingAllo'), 11);
      Stream.Write(FClosingAllow, SizeOf(FClosingAllow));
      with ProgressBar^ do begin
        Stream.Write(BarVisible, SizeOf(BarVisible));
        Stream.Write(BarBorderVisible, SizeOf(BarBorderVisible));
        SaveRectData(Stream, BarBox);
        Stream.Write(BarColor, SizeOf(BarColor));
        Stream.Write(BarBorderColor, SizeOf(BarBorderColor));
        Stream.Write(BarDrawOnTime, SizeOf(BarDrawOnTime));
      end;
      Stream.Write(FProgressBarSectionsCount, SizeOf(FProgressBarSectionsCount));
      if TextData.Count <> 0 then begin
        SaveTextData(Stream);
      end;
      if Icons.Count <> 0 then begin
        SaveIconsData(Stream);
      end;
      if FAnimations.Count <> 0 then begin
        SaveAnimationsData(Stream);
      end;
      Stream.Write(AnsiString('ASF_EndData'), 11);
    finally
      tmpStream.Free;
    end;
  finally
    LeaveCriticalSection(FCritSec);
  end;
end;

procedure TAnimationSplashForm.SaveRectData(Stream: TStream; GPRect: TGPRect);
var
  i: Integer;
begin
  i := SizeOf(integer);
  Stream.Write(GPRect.X, i);
  Stream.Write(GPRect.Y, i);
  Stream.Write(GPRect.Width, i);
  Stream.Write(GPRect.Height, i);
end;

procedure TAnimationSplashForm.SaveStringData(Stream: TStream; Str: String);
var
  i: Integer;
begin
  i := Length(Str){ * 2};
  Stream.Write(i, SizeOf(i));
  Stream.Write(Str[1], i);
end;

procedure TAnimationSplashForm.SaveTextData(Stream: TStream);
var
  I: Integer;
begin
  Stream.Write(AnsiString('ASFTextData'), 11);
  i := TextData.Count;
  Stream.Write(i, SizeOf(i));
  for I := 0 to TextData.Count - 1 do begin
    with TextData.Items[i] do begin
      Stream.Write(Visible, SizeOf(Visible));
      Stream.Write(VisibleShadow, SizeOf(VisibleShadow));
      SaveStringData(Stream, Text);
      SaveRectData(Stream, TextBox);
      Stream.Write(Color, SizeOf(Color));
      Stream.Write(ShadowColor, SizeOf(ShadowColor));
      SaveStringData(Stream, FontName);
      Stream.Write(FontSize, SizeOf(FontSize));
      Stream.Write(FontStyle, SizeOf(FontStyle));
      Stream.Write(PositionH, SizeOf(PositionH));
      Stream.Write(PositionV, SizeOf(PositionV));
      Stream.Write(RenderingHint, SizeOf(RenderingHint));
    end;
  end;
end;

procedure TAnimationSplashForm.SaveIconsData(Stream: TStream);
var
  i: Integer;
  tmpStream: TMemoryStream;
begin
  tmpStream := TMemoryStream.Create;
  try
    Stream.Write(AnsiString('ASFIconData'), 11);
    Stream.Write(ProgressIconsVisible, SizeOf(ProgressIconsVisible));
    Stream.Write(IconFullPaintPercent, SizeOf(IconFullPaintPercent));
    Stream.Write(IconAnimation, SizeOf(IconAnimation));
    Stream.Write(IconPosLeft, SizeOf(IconPosLeft));
    Stream.Write(IconPosTop, SizeOf(IconPosTop));
    Stream.Write(IconSpace, SizeOf(IconSpace));
    Stream.Write(IconStep, SizeOf(IconStep));
    Icons.SaveToStream(tmpStream);
    i := tmpStream.Size;
    Stream.Write(i, SizeOf(i));
    tmpStream.Position := 0;
    Stream.CopyFrom(tmpStream, i);
  finally
    tmpStream.Free;
  end;
end;

procedure TAnimationSplashForm.SaveAnimationsData(Stream: TStream);
var
  i, a: Integer;
  tmpStream, imgStream: TMemoryStream;
begin
  tmpStream := TMemoryStream.Create;
  imgStream := TMemoryStream.Create;
  try
    Stream.Write(AnsiString('ASFAnimData'), 11);
    i := FAnimations.Count;
    tmpStream.Write(i, SizeOf(i));
    for i := 0 to FAnimations.Count - 1 do begin
      imgStream.Clear;
      TAnimationFrames(FAnimations.Items[i]).SaveToStream(imgStream);
      a := imgStream.Size;
      tmpStream.Write(a, SizeOf(a));
      imgStream.Position := 0;
      tmpStream.CopyFrom(imgStream, imgStream.Size);
    end;
    i := tmpStream.Size;
    Stream.Write(i, SizeOf(i));
    tmpStream.Position := 0;
    Stream.CopyFrom(tmpStream, tmpStream.Size);
  finally
    imgStream.Free;
    tmpStream.Free;
  end;
end;

function TAnimationSplashForm.AnimationValidIndex(Index: integer): Boolean;
begin
  Result := (Index >= 0) and (Index < AnimationsCount);
end;

procedure TAnimationSplashForm.TimerProc();
var
  TickCount: Integer;
begin
  if FTickZero = 0 then
    FTickZero := GetTickCount();
  TickCount := GetMyTickCount() - FTickCountOld;
  FTickCountOld := GetMyTickCount();
  if FClose then begin
    if FTransparent >= 0 then begin
      if FWaitClose >= 0 then begin
        Dec(FWaitClose);
      end
      else begin
        FTransparent := FTransparent - FFadeSpeed;
        if FTransparent < 0 then begin
          FTransparent := 0;
          if FDestroy then begin
{            DestroyWindow(AppHandle);}
          //   (DestroyWindow)    
          //      
            FSelfClose := True;
            PostMessage(AppHandle, WM_DESTROY, 0, 0);
          end;
          Exit;
        end;
      end;
    end;
  end
  else begin
    if FTransparent < 255 then begin
      if FTransparent < FTransparentOld then begin
        FTransparent := FTransparent + FFadeSpeed;
        if FTransparent > FTransparentOld then FTransparent := FTransparentOld;
      end
      else begin
        FTransparent := FTransparentOld;
      end;
    end
    else begin
      if (not FEndFadeHasOperated) and (Assigned(FOnEndFade)) then FOnEndFade(Self);
      FEndFadeHasOperated := True;
    end;
  end;
  DrawSplash();
  if FrameNumber = 0 then
    ShowWindow(AppHandle, SW_SHOW);
  Inc(FrameNumber);
  FTickCountAll := FTickCountAll + TickCount;
end;

procedure TAnimationSplashForm.DrawSplash;
var
  GPGraph: TGPGraphics;
  tmpImage: TGPBitmap;
  w, h: Integer;
begin
  w := FBMPBackground.GetWidth;
  h := FBMPBackground.GetHeight;
  tmpImage := TGPBitmap.Create(w, h,PixelFormat32bppARGB);
  tmpImage.SetResolution(FBMPBackground.GetHorizontalResolution, FBMPBackground.GetVerticalResolution);
  GPGraph := TGPGraphics.Create(tmpImage);
  if Assigned(FOnBeforeDraw) then FOnBeforeDraw(Self, GPGraph);
  GPGraph.DrawImage(FBMPBackground, MakeRect(0, 0, w, h), 0, 0, w, h, UnitPixel);
  try
    if TextData.Count <> 0 then begin
      PaintText(GPGraph);
    end;
    if ProgressBar.BarVisible then begin
      PaintProgressBar(GPGraph);
    end;
    if ProgressIconsVisible then begin
      PaintIcons(GPGraph);
    end;
    if FAnimations.Count <> 0 then begin
      PaintAnimations(GPGraph);
    end;
    if Assigned(FOnAfterDraw) then FOnAfterDraw(Self, GPGraph);
    RenderForm(FTransparent, tmpImage);
  finally
    tmpImage.Free;
    GPGraph.Free;
  end;
end;

procedure TAnimationSplashForm.RenderForm(TransparentValue: byte; SourceImage: TGPBitmap);
var
  zsize: TSize;
  zpoint: TPoint;
  zbf: TBlendFunction;
  TopLeft: TPoint;
  WR: TRect;
  GPGraph: TGPGraphics;
  m_hdcMemory: HDC;
  hdcScreen: HDC;
  hBMP: HBITMAP;
begin
  hdcScreen := GetDC(0);
  m_hdcMemory := CreateCompatibleDC(hdcScreen);
  hBMP := CreateCompatibleBitmap(hdcScreen, SourceImage.GetWidth(), SourceImage.GetHeight());
  SelectObject(m_hdcMemory, hBMP);
  GPGraph := TGPGraphics.Create(m_hdcMemory);
  try
{    GPGraph.SetInterpolationMode(InterpolationModeHighQualityBicubic);}
    GPGraph.DrawImage(SourceImage, 0, 0, SourceImage.GetWidth(), SourceImage.GetHeight());
    SetWindowLong(AppHandle, GWL_EXSTYLE, GetWindowLong(AppHandle, GWL_EXSTYLE) or WS_EX_LAYERED);
    zsize.cx := SourceImage.GetWidth;
    zsize.cy := SourceImage.GetHeight;
    zpoint := Point(0, 0);
    with zbf do begin
      BlendOp := AC_SRC_OVER;
      BlendFlags := 0;
      AlphaFormat := AC_SRC_ALPHA;
      SourceConstantAlpha := TransparentValue;
    end;
    GetWindowRect(AppHandle, WR);
    TopLeft := Wr.TopLeft;
    if not FTestSpeed then begin
      UpdateLayeredWindow(AppHandle, FDC, @TopLeft, @zsize, GPGraph.GetHDC, @zpoint, 0, @zbf, ULW_ALPHA);
    end;
  finally
    GPGraph.ReleaseHDC(m_hdcMemory);
    ReleaseDC(0, hdcScreen);
    DeleteObject(hBMP);
    DeleteDC(m_hdcMemory);
    GPGraph.Free;
  end;
end;

procedure TAnimationSplashForm.PaintText(GPGraphics: TGPGraphics);
var
  i: Integer;
  GPRect: TGPRectF;
begin
  for I := 0 to TextData.Count - 1 do begin
    with TextData.Items[i] do begin
      if Visible then begin
        if VisibleShadow then begin
          GPRect := MakeRect(TextBox.X + 1, TextBox.Y + 1, TextBox.Width + 1, Int(TextBox.Height + 1));
          TextOut(TextData.Items[i], TextData.Items[i].ShadowColor, GPGraphics, GPRect);
        end;
        GPRect := MakeRect(TextBox.X, TextBox.Y, TextBox.Width, Int(TextBox.Height));
        TextOut(TextData.Items[i], TextData.Items[i].Color, GPGraphics, GPRect);
      end;
    end;
  end;
end;

procedure TAnimationSplashForm.TextOut(TextInfo: TTextItem; TextColor:
    Cardinal; GPGraphics: TGPGraphics; GPRect: TGPRectF);
var
  GPStrForm: TGPStringFormat;
  GPBrush: TGPBrush;
  GPFont: TGPFont;
begin
  with TextInfo do begin
    GPFont := TGPFont.Create(FontName, FontSize, FontStyle);
    GPBrush := TGPSolidBrush.Create(MakeColor(GetAlpha(TextColor), GetRValue(TextColor), GetGValue(TextColor), GetBValue(TextColor)));
    GPStrForm := TGPStringFormat.Create;
    try
      GPStrForm.SetAlignment(PositionH);
      GPStrForm.SetLineAlignment(PositionV);
      GPGraphics.SetTextRenderingHint(RenderingHint);
      GPGraphics.DrawString(Text, length(Text), GPFont, GPRect, GPStrForm, GPBrush);
    finally
      GPStrForm.Free;
      GPBrush.Free;
      GPFont.Free;
    end;
  end;
end;

procedure TAnimationSplashForm.PaintProgressBar(GPGraphics: TGPGraphics);
var
  I: Integer;
  GPPen: TGPPen;
  W: Integer;
  a: integer;
  ///////////////////
  procedure DrawProgress(const GPRect: TGPRect; SectionNumber: Integer);
  var
    GPBrush: TGPBrush;
  begin
    if SectionNumber <= 0 then
      Exit;
    GPBrush := TGPSolidBrush.Create(FBarSectionsColor[SectionNumber - 1]);
    try
      with ProgressBar^ do begin
        if ProgressBar.BarBorderVisible then begin
          GPGraphics.DrawRectangle(GPPen, BarBox.X, BarBox.Y, BarBox.Width, BarBox.Height);
          GPGraphics.FillRectangle(GPBrush, GPRect.X + 2, GPRect.Y + 2, GPRect.Width, GPRect.Height - 3);
        end
        else begin
          GPGraphics.FillRectangle(GPBrush, GPRect.X, GPRect.Y, GPRect.Width, GPRect.Height);
        end;
      end;
    finally
      GPBrush.Free;
    end;                
  end;
////////////////////
begin
  GPPen := TGPPen.Create(ProgressBar.BarBorderColor);
  try
    if ProgressBar^.BarDrawOnTime then
      w := Round(FTickCountAll / (LoadingSectionTime / FOneSectionProgressSize)) + FStartCurrentSection
    else begin
      w := Round(FOneSectionProgressSize / 100 * ProgressBarPercent) + FStartCurrentSection;
    end;
    if w > FOneSectionProgressSize * ProgressBarCurrentSection then begin
      w := FOneSectionProgressSize * ProgressBarCurrentSection;
    end;
    with ProgressBar^ do begin
      i := 0;
      while i <> FProgressBarCurrentSection do begin
        DrawProgress(MakeRect((I - 1) * FOneSectionProgressSize + BarBox.X, BarBox.Y,
            FOneSectionProgressSize, BarBox.Height), i);
        inc(i);
      end;
      a := w - FStartCurrentSection;
      if ProgressBarCurrentSection = ProgressBarSectionsCount then
         a := w - FStartCurrentSection - 3;
      DrawProgress(MakeRect(FStartCurrentSection + BarBox.X, BarBox.Y, a, BarBox.Height), ProgressBarCurrentSection);
    end;
  finally
    GPPen.Free;
  end;
end;

procedure TAnimationSplashForm.PaintIcons(GPGraphics: TGPGraphics);
var
  I, it, w, h: Integer;
  GPImageAttributes: TGPImageAttributes;
  tmpImage: TGPBitmap;
  aRect: TGPRectF;
  GPGraph: TGPGraphics;
begin
  if Assigned(Icons) then begin
    GPImageAttributes := TGPImageAttributes.Create;
    try
      for i := 0 to Length(FIconPosArray) - 1 do begin
        if FIconPosArray[i].IconIndex = -1 then begin
          it := i - 1;
          Break;
        end;
        it := i;
      end;
      if (it <> -1) and (Length(FIconPosArray) <> 0) then begin
        for I := 0 to it - 1 do begin
          if FIconPosArray[i].IconIndex <> -1 then
            GPGraphics.DrawImage(Icons.Items[FIconPosArray[i].IconIndex],
                FIconPosArray[i].IconPos, IconPosTop);
        end;
        aRect := GetAnimationRect(it, GPImageAttributes);
        w := Icons.Items[FIconPosArray[it].IconIndex].GetWidth;
        h := Icons.Items[FIconPosArray[it].IconIndex].GetHeight;
        tmpImage := TGPBitmap.Create(w, h, PixelFormat32bppARGB);
//        tmpImage.SetResolution(GPGraphics.GetDpiX, GPGraphics.GetDpiY);
        //   -    .   
        tmpImage.SetResolution(Icons.Items[FIconPosArray[it].IconIndex].GetHorizontalResolution,
            Icons.Items[FIconPosArray[it].IconIndex].GetVerticalResolution);
        GPGraph := TGPGraphics.Create(tmpImage);
        GPGraph.DrawImage(Icons.Items[FIconPosArray[it].IconIndex],
            MakeRect(0, 0, w, h), 0, 0, w, h, UnitPixel);
        GPGraphics.DrawImage(tmpImage, aRect, 0, 0, aRect.Width, aRect.Height,
            UnitPixel, GPImageAttributes);
        tmpImage.Free;
        GPGraph.Free;
      end;
    finally
      GPImageAttributes.Free;
    end;
  end;
end;

function TAnimationSplashForm.GetAnimationRect(ItemIndex: Integer;
    GPImageAttributes: TGPImageAttributes): TGPRectF;
const
  c299 = 1 - 0.299;
  c587 = 1 - 0.587;
  c114 = 1 - 0.114;
var
  a, tc: Real;
begin
  tc := FTickCountAll / (LoadingSectionTime * (IconFullPaintPercent / 100));
  case IconAnimation of
    iaNone: begin
        Result := MakeRect(CalcCurrentIconPos(ItemIndex), IconPosTop,
              Int(FIconPosArray[ItemIndex].IconWidth),
              Int(FIconPosArray[ItemIndex].IconHeight));
      end;
    iaFade: begin
        a := tc;
        if a > 1 then
          a := 1;
        FadeColorMatrix[3, 3] := a;
        GPImageAttributes.SetColorMatrix(FadeColorMatrix);
        Result := MakeRect(CalcCurrentIconPos(ItemIndex), IconPosTop,
              Int(FIconPosArray[ItemIndex].IconWidth),
              Int(FIconPosArray[ItemIndex].IconHeight));
      end;
    iaFadeColor: begin
        a := c299 + (c299 * tc);
        if a > 1 then a := 1;
        FadeColorColorMatrix[0, 0] := a;
        a := 0.299 - (0.299 * tc);
        if a < 0 then a := 0;
        FadeColorColorMatrix[0, 1] := a;
        FadeColorColorMatrix[0, 2] := a;
        a := c587 + (c587 * tc);
        if a > 1 then a := 1;
        FadeColorColorMatrix[1, 1] := a;
        a := 0.587 - (0.587 * tc);
        if a < 0 then a := 0;
        FadeColorColorMatrix[1, 0] := a;
        FadeColorColorMatrix[1, 2] := a;
        a := c114 + (c114 * tc);
        if a > 1 then a := 1;
        FadeColorColorMatrix[2, 2] := a;
        a := 0.114 - (0.114 * tc);
        if a < 0 then a := 0;
        FadeColorColorMatrix[2, 0] := a;
        FadeColorColorMatrix[2, 1] := a;
        GPImageAttributes.SetColorMatrix(FadeColorColorMatrix);
        Result := MakeRect(CalcCurrentIconPos(ItemIndex), IconPosTop,
              Int(FIconPosArray[ItemIndex].IconWidth),
              Int(FIconPosArray[ItemIndex].IconHeight));
      end;
    iaSlideTop: begin
        Result := MakeRect(CalcCurrentIconPos(ItemIndex), IconPosTop,
              Int(FIconPosArray[ItemIndex].IconWidth),
              Round(FIconPosArray[ItemIndex].IconHeight * tc));
      end;
    iaSlideLeft: begin
        Result := MakeRect(CalcCurrentIconPos(ItemIndex), IconPosTop,
              Round(FIconPosArray[ItemIndex].IconWidth * tc),
              Int(FIconPosArray[ItemIndex].IconHeight));
      end;
    iaSlideCorner: begin
        Result := MakeRect(CalcCurrentIconPos(ItemIndex), IconPosTop,
              Round(FIconPosArray[ItemIndex].IconWidth * tc),
              Round(FIconPosArray[ItemIndex].IconHeight * tc));
      end;
  end;
end;

procedure TAnimationSplashForm.PaintAnimations(GPGraphics: TGPGraphics);
var
  i: Integer;
begin
  for i := 0 to FAnimations.Count - 1 do begin
    with TAnimationFrames(FAnimations.Items[i]) do begin
      if Count <> 0 then begin
        GPGraphics.DrawImage(Items[NumCurrentLoadingImage], PositionLeft, PositionTop);
        CalculateDelay;
      end;
    end;
  end;
end;
                             
procedure TAnimationSplashForm.PressKey(var aMsg: TMsg; EventType: TEventType);
var
  a: Word;
  c: Char;
begin
  case EventType of
    etKeyDown: begin
      if Assigned(FonKeyDown) then begin
        a := aMsg.wParam;
        FonKeyDown(Self, a, KeyDataToShiftState(aMsg.lParam));
        aMsg.wParam := a;
      end;
    end;
    etKeyUp: begin
      if Assigned(FonKeyUp) then begin
        a := aMsg.wParam;
        FonKeyUp(Self, a, KeyDataToShiftState(aMsg.lParam));
        aMsg.wParam := a;
      end;
    end;
    etKeyPress: begin
      if Assigned(FonKeyPress) then begin
        c := Char(aMsg.wParam);
        FonKeyPress(Self, c);
        aMsg.wParam := Ord(c);
      end;
    end;
  end;

end;

end.